/*
 **************************************************************************
 *
 *	REX-USB70 Win32 Communication API Sample Program
 *
 *	Compiler : Microsoft Visual C/C++ 6.0
 *
 *	(C)RATOC Systems,Inc.	Version : 1.0   Data : 2012.01.27
 *
 *	History
 *	2012.01.27 V1.0 New create
 *
 **************************************************************************
 */
#include	<windows.h>
#include 	<commdlg.h>
#include 	<stdio.h>
#include 	"resource.h"

#define		MsgTitle	"Win32Com"

/* RS232CŎgpꍇ́ALRS485/RS422̒`𖳌ɂĂ */

/* RS485(d)Ŏgpꍇ́AL̒`LɂĂ */
#define		RS485
/* RS422Ŏgpꍇ́AL̒`LɂĂ */
//#define		RS422

HINSTANCE 	hInst;
char szAppName[] = "MainDlg";

LPCSTR 		lpszComName; //COM߰Ė
HANDLE 		hCom;
COMMCONFIG 	cc;
BOOL 		fReadThread = FALSE;
HANDLE 		hThread = NULL;


/*
 *	ߐ錾
 */
int APIENTRY WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
DWORD WINAPI ReadThread( LPVOID lpParameter );
void ShowError( LPCSTR str );

/*
 *
 *	 	WinMain( HINSTANCE, HINSTANCE, LPSTR, BOOL )
 *
 *	@ \	֐̌Ăяoүٰߏ
 *
 *	 	HINSTANCE hInstance     : ݂̲ݽݽ
 *			HINSTANCE hPrevInstance : ȑO̲ݽݽ
 *			LPSTR  lpszCmdLine      : ײ
 *			BOOL   nCmdShow         : \
 *
 *	 l	PostQuitMessage֐̖߂lԂ
 *
 */
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HWND Rethwd;

    if ( !hPrevInstance )
    	if ( !InitApplication( hInstance ) )
        	return FALSE;

	if ( (BOOL)Rethwd = InitInstance(hInstance, nCmdShow) == FALSE )
    	return FALSE;

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if(!IsDialogMessage( Rethwd, &msg ))
		{
        	TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
    return msg.wParam;
}


/*
 *
 *	 	BOOL InitApplication( HINSTANCE )
 *
 *	@ \	޳ް̏Ƴ޳׽̓o^
 *
 *	 	HINSTANCE hInstance	: ݂̲ݽݽ
 *
 *	 l	޳׽o^A܂͎sނԂ
 *
 */
BOOL InitApplication(HINSTANCE hInstance)
{
    WNDCLASS  wc;

    wc.style         = (UINT)NULL;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = DLGWINDOWEXTRA;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW);
    wc.lpszMenuName  = szAppName;
    wc.lpszClassName = szAppName;

    return(RegisterClass(&wc));
}

/*
 *
 *	 	BOOL InitInstance( HINSTANCE, BOOL )
 *
 *	@ \	CEBhEnh
 *
 *	 	HINSTANCE hInstance : ݂̲ݽݽ
 *			BOOL   nCmdShow     : ŏShowWindow()Ăяö
 *
 *	 l	PostQuitMessage̖߂lԂ
 *
 */
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
    HWND    hwnd;
    hInst = hInstance;

    hwnd = CreateDialog( hInstance, MAKEINTRESOURCE(IDD_MAINDLG), 0, ( DLGPROC )WndProc );
	if (!hwnd)
    	return FALSE;

    ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );

    return (BOOL)hwnd;
}

/*
 *
 *	 	LRESULT CALLBACK ComDlgProc( HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
 *
 *	@ \	COM߰đI޲۸
 *
 *	 	HWND   hwnd     : ޳
 *			UINT   uMessage : үނ
 *			WPARAM wParam   : ǉ
 *			LPARAM lParam   : ǉ
 *
 *	 l	үނ͂̂܂ܓn
 *
 */
LRESULT CALLBACK ComDlgProc( HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	WORD  ch;
	PCHAR str[]={"COM1","COM2","COM3","COM4","COM5","COM6","COM7","COM8" };

	switch (uMessage)
    {
	case WM_INITDIALOG:
		// ޯɱтǉ
		for( ch = 0; ch < 8; ch++ )
		{
			SendDlgItemMessage( hwnd, IDC_COMNUM, CB_ADDSTRING, 0, (LPARAM)str[ch] );
		}
		// ޯ̱тI
		SendDlgItemMessage( hwnd, IDC_COMNUM, CB_SETCURSEL, 0, 0 );
		return FALSE;
    case WM_COMMAND:
		switch( wParam )
        {
		case IDOK:
			// ޯCOMI
			ch = (BYTE)SendDlgItemMessage( hwnd, IDC_COMNUM, CB_GETCURSEL, 0, 0 );
			lpszComName = str[ch];
			EndDialog( hwnd, FALSE );
			return TRUE;
		case IDCANCEL:
			EndDialog( hwnd, TRUE );
			return TRUE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
}


/*
 *
 *	 	LRESULT CALLBACK WndProc( HWND hwnd, UINT uMessage, UINT wParam, LONG lParam )
 *
 *	@ \	޳үނɏ]Ċe폈s
 *
 *	 	HWND   hwnd     : ޳
 *			UINT   uMessage : үނ
 *			WPARAM wParam   : ǉ
 *			LPARAM lParam   : ǉ
 *
 *	 l	үނ͂̂܂ܓn
 *
 */
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	BYTE	TxBuf[256];
	DWORD	nToWrite;
	DWORD	dwBytesWrote;
	DWORD 	ThreadId;
	DWORD	RetVal;
	COMMTIMEOUTS 	cto = { 2, 1, 1, 0, 0 };
    DCB 			dcb;
	OVERLAPPED 		ov;
	int 			iRet = 0 ;

	switch (uMessage)
    {
	case WM_CREATE:
		// үނ߽
   		PostMessage( hWnd, WM_COMMAND, IDD_COMDLG, 0L );
		return TRUE ;
    case WM_COMMAND:
		switch( wParam )
        {
        case IDD_COMDLG:
			RetVal = DialogBox( hInst, MAKEINTRESOURCE(IDD_COMDLG), hWnd, ( DLGPROC )ComDlgProc );
			if( RetVal == TRUE )
			{
		        PostQuitMessage(0);
				break;
			}
			// COM߰ĵ
			hCom = CreateFile( lpszComName,
								GENERIC_READ|GENERIC_WRITE,
								0,
								NULL,
								OPEN_EXISTING,
                    			FILE_FLAG_OVERLAPPED,
								NULL);
			if ( hCom == INVALID_HANDLE_VALUE) {
				// ٴװ
		    	ShowError("COM Open Error.");
				return FALSE;
			}

			// ʐMҰݒ
			if ( !SetCommTimeouts(hCom,&cto) )
      			ShowError("Set COM timeout error.");
	         // DCBݒ
    	     memset(&dcb,0,sizeof(dcb));
        	 dcb.DCBlength = sizeof(dcb);
	         dcb.BaudRate = 9600;
    	     dcb.fBinary = 1;
        	 dcb.fDtrControl = DTR_CONTROL_ENABLE;
	         dcb.fOutxCtsFlow = 1;
    	     dcb.fRtsControl = RTS_CONTROL_ENABLE;
	         dcb.Parity = NOPARITY;
    	     dcb.StopBits = ONESTOPBIT;
        	 dcb.ByteSize = 8;

			// VɒʐMҰݒ肷
			if ( !SetCommState( hCom, &dcb) )
      			ShowError("Set COM parameter error.");

			// Signal event every 
			SetCommMask( hCom, EV_RXCHAR );

#ifdef RS485
			/* RS485̏ꍇDTR펞݂ɂāAʏ펩Mް
			   Ŏ󂯂đMްmF܂ */
			EscapeCommFunction( hCom, SETDTR );	// MȰ
			// RS485̏ꍇRTSMOFFɂ邱ƂőMިقɂ܂B
			EscapeCommFunction( hCom, CLRRTS );	// Mި
#endif
#ifdef RS422
			// RS422̏ꍇRTSMONɂ邱ƂőMȰقɂ܂B
			EscapeCommFunction( hCom, SETRTS );	// MȰ
#endif

			break;
        case IDB_TXDATA:
			// Mް擾
			memset( TxBuf, 0x00, sizeof( TxBuf ) );
			GetDlgItemText( hWnd, IDE_TXDATA, TxBuf, sizeof(TxBuf) );
			SetDlgItemText( hWnd, IDS_TXDATA, TxBuf );
			SetDlgItemText( hWnd, IDE_TXDATA, "" );
			nToWrite = strlen(TxBuf);

#ifdef RS485
			// dʐM̏ꍇAMf[^̍Ō0xFFtāAgɎMm点܂B
			TxBuf[nToWrite] = 0xFF;
			nToWrite++;
#endif

			// ĵ޼ުď
			memset(&ov,0,sizeof(ov));
			ov.hEvent = CreateEvent( 0,TRUE,0,0);

#ifdef RS485
			// RS485̏ꍇ͑MRTSMON
			EscapeCommFunction( hCom, SETRTS );	// MȰ
#endif

			// COM߰ĂްM
			iRet = WriteFile ( hCom, TxBuf, nToWrite, &dwBytesWrote, &ov);
			if ( iRet == 0 )
			{
				WaitForSingleObject(ov.hEvent ,1000);
			}

			CloseHandle(ov.hEvent);

			break;

		case IDB_RXDATA:
			// Mگނ쐬܂
			hThread = CreateThread( NULL,
									0, 
									(LPTHREAD_START_ROUTINE)ReadThread,
									hWnd,
									0,
									&ThreadId);
			if ( hThread == INVALID_HANDLE_VALUE)
			{
		    	ShowError("Data receive thread create error.");
			}
            break;
        }
        break;
    case WM_DESTROY:
		if(hThread != NULL)
		{
			CloseHandle( hThread );
			fReadThread = FALSE;
		}
		if(hCom != NULL)
			CloseHandle( hCom );
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, uMessage, wParam, lParam);
    }
    return 0;
}

/*
 *
 *	 	DWORD ReadThread( HWND hwnd )
 *
 *	@ \	Mگ
 *
 *	 	HWND   hwnd     : ޳
 *
 *	 l	0Ԃ
 *
 */
DWORD WINAPI ReadThread( LPVOID lpParameter )
{
	OVERLAPPED 	ov;
	BYTE 		RxBuf[256];
	DWORD 		dwBytesRead, dwEvent, WinError;
	HWND		hWnd;
	DWORD totalbyte;

	totalbyte = 0;
	fReadThread = TRUE;
	hWnd = (HWND)lpParameter;
	memset(&ov,0,sizeof(ov));
	ov.hEvent = CreateEvent( 0,TRUE,0,0);

	memset(RxBuf,0,sizeof(RxBuf));
	// ޲ĎMĂ҂ĎMްoi[
	while( fReadThread )
	{
		// Ă҂
		WaitCommEvent(hCom,&dwEvent, &ov) ;

		if ( WaitForSingleObject(ov.hEvent,INFINITE) == WAIT_OBJECT_0)
		{
			do
			{
				if( !ReadFile( hCom, (PCHAR)( RxBuf + totalbyte ),sizeof(RxBuf),&dwBytesRead,&ov) )
				{
					if( (WinError = GetLastError()) == ERROR_IO_PENDING )
					{
						if( !GetOverlappedResult(hCom,&ov,&dwBytesRead,TRUE) )
						{
							ShowError("GetOverlappedResult failed");
							break;
						}
					} else {
						if(WinError != ERROR_INVALID_HANDLE)
							ShowError("ReadFile failed");
						break;
					}
				}

				if ( dwBytesRead > 0 )
				{
					totalbyte += dwBytesRead;
					// Mް\
					RxBuf[totalbyte] = 0x00;
					SetDlgItemText( hWnd, IDS_RXDATA, RxBuf );

#ifdef RS485
					if( RxBuf[totalbyte - 1] == 0xFF )
					{
						RxBuf[totalbyte - 1] = 0x00;
						SetDlgItemText( hWnd, IDS_RXDATA, RxBuf );
						// RS485̏ꍇ͑MRTSMOFF
						EscapeCommFunction( hCom, CLRRTS );	// Mި

						memset(RxBuf,0,sizeof(RxBuf));
						totalbyte = 0;
					}

#endif
				}
			}while (dwBytesRead > 0 && fReadThread != FALSE);	
		}
	}	// while

	return 0L;
}

/*
 *
 *	 	void ShowError( LPCSTR str )
 *
 *	@ \	ڍ״װ̕\
 *
 *	 	LPCSTR str : \װүނւ߲
 *
 *	 l	Ȃ
 *
 */
void ShowError( LPCSTR str )
{
	char MsgBuf[256];
	LPVOID lpMessageBuffer;
	int error = GetLastError();

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		error,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMessageBuffer,
		0,
		NULL
		);
	sprintf(MsgBuf, "%s: (%d) %s\n",str,error,lpMessageBuffer);
	MessageBox( NULL, MsgBuf, MsgTitle, MB_OK );
	LocalFree( lpMessageBuffer );
}


// End of File
